unit untMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, untPeFile;

type
  TfrmMain = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label5: TLabel;
    Label10: TLabel;
    lvEAT: TListView;
    edtName: TEdit;
    edtCharacteristics: TEdit;
    edtTimeDateStamp: TEdit;
    edtVersion: TEdit;
    edtBase: TEdit;
    edtNumberOfFunctions: TEdit;
    edtNumberOfNames: TEdit;
    edtAddressOfNames: TEdit;
    edtAddressOfNameOrdinals: TEdit;
    edtAddressOfFunctions: TEdit;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

const
 sFormatStr                = '%2.8x';
 sFormatStr2               = '%2.4x';

procedure TfrmMain.FormCreate(Sender: TObject);
var
  Pe: TPeFile;
  sFilename: string;
  lpBuffer: array[0..MAX_PATH] of Char;
  ExportData: TExports;
  x: Integer;
  ListItem: TListItem;
begin
  GetSystemDirectory(lpBuffer, SizeOf(lpBuffer));
  sFilename := string(lpBuffer) + '\shell32.dll';
  Pe := TPeFile.Create;
  if Pe.LoadFromFile(sFilename) then
  begin
    pe.GetExportsAddressTable(ExportData);
    edtName.Text := ExportData.LibraryName;
    edtBase.Text := Format(sFormatStr, [ExportData.Base]);
    edtCharacteristics.Text := Format(sFormatStr, [ExportData.Characteristics]);
    edtTimeDateStamp.Text := Format(sFormatStr, [ExportData.TimeDateStamp]);
    edtVersion.Text := Format('%d.%d', [ExportData.MajorVersion, ExportData.MinorVersion]);
    edtNumberOfFunctions.Text := Format(sFormatStr, [ExportData.NumberOfFunctions]);
    edtNumberOfNames.Text := Format(sFormatStr, [ExportData.NumberOfNames]);
    edtAddressOfNames.Text := Format(sFormatStr, [Cardinal(ExportData.AddressOfNames)]);
    edtAddressOfFunctions.Text := Format(sFormatStr, [Cardinal(ExportData.AddressOfFunctions)]);
    edtAddressOfNameOrdinals.Text := Format(sFormatStr, [Cardinal(ExportData.AddressOfNameOrdinals)]);
    for x := Low(ExportData.ExportFunctions) to High(ExportData.ExportFunctions) do
    begin
      ListItem := lvEAT.Items.Add;
      ListItem.Caption := Format(sFormatStr2, [ExportData.exportfunctions[x].Ordinal]);
      ListItem.SubItems.Add(Format(sFormatStr, [ExportData.ExportFunctions[x].Rva]));
      ListItem.SubItems.Add(Format(sFormatStr, [ExportData.ExportFunctions[x].FileOffset]));
      ListItem.subitems.Add(ExportData.exportfunctions[x].ApiName);
    end;
  end;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
