unit untMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, untPeFile;

type
  TfrmMain = class(TForm)
    lvLibrary: TListView;
    lvFunctions: TListView;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure lvLibrarySelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvLibraryClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure ShowIat(var Pe: TPeFile);
    procedure ShowIatFunctions(Selected: Integer);
    { Private-Deklarationen }
  public
    Imports: TImportsArray;
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

const
 sFormatStr                = '%2.8x';
 sFormatStr2               = '%2.4x';

procedure TfrmMain.ShowIat(var Pe: TPeFile);
var
  x: Integer;
  ListItem: TListItem;
begin
  lvLibrary.Clear;
  lvLibrary.Items.BeginUpdate;
  Pe.GetImportAddressTable(Imports);
  for x := Low(Imports) to High(Imports) do
  begin
    if (Imports[x].ImportType = itDelay) then
      Imports[x].LibraryName := Imports[x].LibraryName + '(Delay)'
    else if (Imports[x].ImportType = itBound) then
      Imports[x].LibraryName := Imports[x].LibraryName + '(Bound)';
    ListItem := lvLibrary.Items.Add;
    ListItem.Caption := Imports[x].LibraryName;
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[x].OriginalFirstThunk]));
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[x].TimeDateStamp]));
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[x].ForwarderChain]));
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[x].Name]));
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[x].FirstThunk]));
  end;
  lvLibrary.Items.EndUpdate;
end;

procedure TfrmMain.ShowIatFunctions(Selected: Integer);
var
  x: Integer;
  ListItem: TListItem;
begin
  lvFunctions.Clear;
  lvFunctions.Items.BeginUpdate;
  for x := Low(Imports[Selected].IatFunctions) to High(Imports[Selected].IatFunctions) do
  begin
    ListItem := lvFunctions.Items.Add;
    ListItem.Caption :=   Format(sFormatStr, [Imports[Selected].IatFunctions[x].ThunkRVA]);
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[Selected].IatFunctions[x].ThunkOffset]));
    ListItem.SubItems.Add(Format(sFormatStr, [Imports[Selected].IatFunctions[x].ThunkValue]));
    ListItem.SubItems.Add(Format(sFormatStr2, [Imports[Selected].IatFunctions[x].Hint]));
    ListItem.SubItems.Add(Imports[Selected].IatFunctions[x].ApiName);
  end;
  lvFunctions.Items.EndUpdate;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  Pe: TPeFile;
begin
  Pe := TPeFile.Create;
  if Pe.LoadFromFile(Application.ExeName) then
  begin
    ShowIat(Pe);
  end;
  Pe.Free;
end;

procedure TfrmMain.lvLibrarySelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  lvLibraryClick(Sender);
end;

procedure TfrmMain.lvLibraryClick(Sender: TObject);
begin
  if (lvLibrary.Selected <> nil) then
    ShowIatFunctions(lvLibrary.Selected.Index);
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
