unit untMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, StdCtrls, untPeFile, Menus;

type
  TfrmMain = class(TForm)
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    edtCharacteristics: TEdit;
    edtTimeDateStamp: TEdit;
    edtVersion: TEdit;
    edtNumberOfNamedEntries: TEdit;
    edtNumberOfIdEntries: TEdit;
    Button2: TButton;
    lvResources: TListView;
    lvSubResources: TListView;
    ImageList1: TImageList;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    DumpasBIN1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lvResourcesClick(Sender: TObject);
    procedure lvResourcesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DumpasBIN1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    Pe: TPeFile;
    Res: TResources;
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

const
 sFormatStr                = '%2.8x';
 sFormatStr2               = '%2.4x';

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  x: Integer;
  ListItem: TListItem;
begin
  Pe := TPeFile.Create;
  if Pe.LoadFromFile('c:\windows\notepad.exe') then
  begin
    Pe.GetResources(Res);
    edtCharacteristics.Text := Format(sFormatStr, [Res.Dir.Characteristics]);
    edtTimeDateStamp.Text := Format(sFormatStr, [Res.Dir.TimeDateStamp]);
    edtVersion.Text := Format('%d.%d', [Res.Dir.MajorVersion, Res.Dir.MinorVersion]);
    edtNumberOfNamedEntries.Text := Format(sFormatStr2, [Res.Dir.NumberOfNamedEntries]);
    edtNumberOfIdEntries.Text := Format(sFormatStr2, [Res.Dir.NumberOfIdEntries]);
    for x := Low(Res.Entries) to High(Res.Entries) do
    begin
      ListItem := lvResources.Items.Add;
      ListItem.Caption := Res.Entries[x].sTyp;
      ListItem.ImageIndex := 0;
    end;
  end;
//  Pe.Free;
end;

procedure TfrmMain.lvResourcesClick(Sender: TObject);
var
  x: Integer;
  ListItem: TListItem;
begin
  lvSubResources.Clear;
  lvSubResources.Items.BeginUpdate;
  if (lvResources.Selected <> nil) then
  begin
    for x := Low(Res.Entries[lvResources.Selected.Index].NameEntries) to High(Res.Entries[lvResources.Selected.Index].NameEntries) do
    begin
      ListItem := lvSubResources.Items.Add;
      ListItem.Caption := Res.Entries[lvResources.Selected.Index].NameEntries[x].sName;
      ListItem.SubItems.Add(Format(sFormatStr, [Res.Entries[lvResources.Selected.Index].NameEntries[x].dwDataRVA]));
      ListItem.SubItems.Add(Format(sFormatStr, [Res.Entries[lvResources.Selected.Index].NameEntries[x].dwsize]));
      ListItem.SubItems.Add(Res.Entries[lvResources.Selected.Index].NameEntries[x].sLang);
    end;
  end;
  lvSubResources.Items.EndUpdate;
end;

procedure TfrmMain.lvResourcesSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  lvResourcesClick(Sender);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Pe.Free;
end;

procedure TfrmMain.DumpasBIN1Click(Sender: TObject);
var
  hFile: THandle;
  lpNumberOfBytesWritten: DWORD;
begin
  if (lvSubResources.Selected <> nil) and (lvResources.Selected <> nil) then
  begin
    hFile := CreateFile('x.bin', GENERIC_WRITE, FILE_SHARE_WRITE, nil, CREATE_ALWAYS, 0, 0);
    if (hFile <> INVALID_HANDLE_VALUE) then
    begin
      WriteFile(hFile,
        Res.Entries[lvResources.Selected.Index].NameEntries[lvSubResources.Selected.Index].lpData^,
        Res.Entries[lvResources.Selected.Index].NameEntries[lvSubResources.Selected.Index].dwSize,
        lpNumberOfBytesWritten,
        nil);
      CloseHandle(hFile);
    end;
  end;
end;

end.
